# QwtPlotScaleItem Class Reference

Inheritance diagram for QwtPlotScaleItem:

[legend]
Collaboration diagram for QwtPlotScaleItem:

[legend]
List of all members.

## Detailed Description

A class which draws a scale inside the plot canvas.

QwtPlotScaleItem can be used to draw an axis inside the plot canvas. It might by synchronized to one of the axis of the plot, but can also display its own ticks and labels.

It is allowed to synchronize the scale item with a disabled axis. In plots with vertical and horizontal scale items, it might be necessary to remove ticks at the intersections, by overloading updateScaleDiv().

The scale might be at a specific position (f.e 0.0) or it might be aligned to a canvas border.

Example
  The following example shows how to replace the left axis, by a scale item at the x position 0.0.

      QwtPlotScaleItem *scaleItem =
          new QwtPlotScaleItem(QwtScaleDraw::RightScale, 0.0);
      scaleItem->setFont(plot->axisWidget(QwtPlot::yLeft)->font());
      scaleItem->attach(plot);

      plot->enableAxis(QwtPlot::yLeft, false);

Definition at line 51 of file qwt_plot_scaleitem.h.

## Public Member Functions

| QwtPlotScaleItem (QwtScaleDraw::Alignment=QwtScaleDraw::BottomScale, const double pos=0.0)
virtual | ~QwtPlotScaleItem ()
virtual int | rtti () const
void | setScaleDiv (const QwtScaleDiv &)
const QwtScaleDiv & | scaleDiv () const
void | setScaleDivFromAxis (bool on)
bool | isScaleDivFromAxis () const
void | setPalette (const QPalette &)
QPalette | palette () const
void | setFont (const QFont &)
QFont | font () const
void | setScaleDraw (QwtScaleDraw *)
const QwtScaleDraw * | scaleDraw () const
QwtScaleDraw * | scaleDraw ()
void | setPosition (double pos)
double | position () const
void | setBorderDistance (int numPixels)
int | borderDistance () const
void | setAlignment (QwtScaleDraw::Alignment)
virtual void | draw (QPainter *p, const QwtScaleMap &xMap, const QwtScaleMap &yMap, const QRect &rect) const
virtual void | updateScaleDiv (const QwtScaleDiv &, const QwtScaleDiv &)

## Constructor & Destructor Documentation

QwtPlotScaleItem::QwtPlotScaleItem | ( | QwtScaleDraw::Alignment | alignment = `QwtScaleDraw::BottomScale`,
|  | const double | pos = `0.0` |
| ) |  |  | `[explicit]`

Constructor for scale item at the position pos.

Parameters:

  | alignment | In case of QwtScaleDraw::BottomScale/QwtScaleDrawTopScale the scale item is corresponding to the xAxis(), otherwise it corresponds to the yAxis().
  | position | x or y position, depending on the corresponding axis.

See also:
  setPosition(), setAlignment()

Definition at line 58 of file qwt_plot_scaleitem.cpp.

References QwtPlotItem::setZ().

QwtPlotScaleItem::~QwtPlotScaleItem | ( |  | ) | `[virtual]`

Destructor.

Definition at line 70 of file qwt_plot_scaleitem.cpp.

## Member Function Documentation

int QwtPlotScaleItem::rtti | ( |  | ) | const`[virtual]`

Returns:
  QwtPlotItem::Rtti_PlotScale

Reimplemented from QwtPlotItem.

Definition at line 76 of file qwt_plot_scaleitem.cpp.

void QwtPlotScaleItem::setScaleDiv | ( | const QwtScaleDiv & | scaleDiv | ) |

Assign a scale division.

When assigning a scaleDiv the scale division won't be synchronized with the corresponding axis anymore.

Parameters:

  | scaleDiv | Scale division

See also:
  scaleDiv(), setScaleDivFromAxis(), isScaleDivFromAxis()

Definition at line 90 of file qwt_plot_scaleitem.cpp.

References scaleDiv().

const QwtScaleDiv & QwtPlotScaleItem::scaleDiv | ( |  | ) | const

Returns:
  Scale division

Definition at line 97 of file qwt_plot_scaleitem.cpp.

Referenced by setScaleDiv().

void QwtPlotScaleItem::setScaleDivFromAxis | ( | bool | on | ) |

Enable/Disable the synchronization of the scale division with the corresponding axis.

See also:
  isScaleDivFromAxis()

Definition at line 108 of file qwt_plot_scaleitem.cpp.

References QwtPlot::axisScaleDiv(), QwtPlotItem::itemChanged(), QwtPlotItem::plot(), updateScaleDiv(), QwtPlotItem::xAxis(), and QwtPlotItem::yAxis().

bool QwtPlotScaleItem::isScaleDivFromAxis | ( |  | ) | const

Returns:
  True, if the synchronization of the scale division with the corresponding axis is enabled.

See also:
  setScaleDiv(), setScaleDivFromAxis()

Definition at line 131 of file qwt_plot_scaleitem.cpp.

void QwtPlotScaleItem::setPalette | ( | const QPalette & | palette | ) |

Set the palette

See also:
  QwtAbstractScaleDraw::draw(), palette()

Definition at line 166 of file qwt_plot_scaleitem.cpp.

References QwtPlotItem::itemChanged().

QPalette QwtPlotScaleItem::palette | ( |  | ) | const

Returns:
  palette

See also:
  setPalette()

Definition at line 179 of file qwt_plot_scaleitem.cpp.

void QwtPlotScaleItem::setFont | ( | const QFont & | font | ) |

Change the tick label font

See also:
  font

Definition at line 190 of file qwt_plot_scaleitem.cpp.

References QwtPlotItem::itemChanged().

QFont QwtPlotScaleItem::font | ( |  | ) | const

Returns:
  tick label font

See also:
  setFont()

Definition at line 203 of file qwt_plot_scaleitem.cpp.

void QwtPlotScaleItem::setScaleDraw | ( | QwtScaleDraw * | scaleDraw | ) |

Set a scale draw.

Parameters:

  | axisId | axis index
  | scaleDraw | object responsible for drawing scales.

The main use case for replacing the default QwtScaleDraw is to overload QwtAbstractScaleDraw::label, to replace or swallow tick labels.

See also:
  scaleDraw()

Definition at line 220 of file qwt_plot_scaleitem.cpp.

References QwtPlot::axisScaleDiv(), QwtPlotItem::itemChanged(), QwtPlotItem::plot(), scaleDraw(), updateScaleDiv(), QwtPlotItem::xAxis(), and QwtPlotItem::yAxis().

const QwtScaleDraw * QwtPlotScaleItem::scaleDraw | ( |  | ) | const

Returns:
  Scale draw

See also:
  setScaleDraw()

Definition at line 244 of file qwt_plot_scaleitem.cpp.

Referenced by setScaleDraw().

QwtScaleDraw * QwtPlotScaleItem::scaleDraw | ( |  | ) |

Returns:
  Scale draw

See also:
  setScaleDraw()

Definition at line 253 of file qwt_plot_scaleitem.cpp.

void QwtPlotScaleItem::setPosition | ( | double | pos | ) |

Change the position of the scale

The position is interpreted as y value for horizontal axes and as x value for vertical axes.

The border distance is set to -1.

See also:
  position(), setAlignment()

Definition at line 268 of file qwt_plot_scaleitem.cpp.

References QwtPlotItem::itemChanged().

double QwtPlotScaleItem::position | ( |  | ) | const

Returns:
  Position of the scale

See also:
  setPosition(), setAlignment()

Definition at line 282 of file qwt_plot_scaleitem.cpp.

void QwtPlotScaleItem::setBorderDistance | ( | int | distance | ) |

Align the scale to the canvas.

If distance is >= 0 the scale will be aligned to a border of the contents rect of the canvas. If alignment() is QwtScaleDraw::LeftScale, the scale will be aligned to the right border, if it is QwtScaleDraw::TopScale it will be aligned to the bottom (and vice versa),

If distance is < 0 the scale will be at the position().

Parameters:

  | distance | Number of pixels between the canvas border and the backbone of the scale.

See also:
  setPosition(), borderDistance()

Definition at line 303 of file qwt_plot_scaleitem.cpp.

References QwtPlotItem::itemChanged().

int QwtPlotScaleItem::borderDistance | ( |  | ) | const

Returns:
  Distance from a canvas border

See also:
  setBorderDistance(), setPosition()

Definition at line 319 of file qwt_plot_scaleitem.cpp.

void QwtPlotScaleItem::setAlignment | ( | QwtScaleDraw::Alignment | alignment | ) |

Change the alignment of the scale

The alignment sets the orientation of the scale and the position of the ticks:

- QwtScaleDraw::BottomScale: horizontal, ticks below
- QwtScaleDraw::TopScale: horizontal, ticks above
- QwtScaleDraw::LeftScale: vertical, ticks left
- QwtScaleDraw::RightScale: vertical, ticks right

For horizontal scales the position corresponds to QwtPlotItem::yAxis(), otherwise to QwtPlotItem::xAxis().

See also:
  scaleDraw(), QwtScaleDraw::alignment(), setPosition()

Definition at line 340 of file qwt_plot_scaleitem.cpp.

References QwtScaleDraw::alignment(), QwtPlotItem::itemChanged(), and QwtScaleDraw::setAlignment().

void QwtPlotScaleItem::draw | ( | QPainter * | p,
|  | const QwtScaleMap & | xMap,
|  | const QwtScaleMap & | yMap,
|  | const QRect & | rect |
| ) |  |  | const`[virtual]`

Draw the scale.

Implements QwtPlotItem.

Definition at line 353 of file qwt_plot_scaleitem.cpp.

References QwtScaleDraw::alignment(), QwtScaleTransformation::copy(), QwtAbstractScaleDraw::draw(), QwtScaleDraw::move(), QwtScaleDraw::orientation(), QwtScaleDraw::setLength(), QwtAbstractScaleDraw::setTransformation(), QwtScaleMap::transform(), QwtScaleMap::transformation(), and updateBorders().

void QwtPlotScaleItem::updateScaleDiv | ( | const QwtScaleDiv & | xScaleDiv,
|  | const QwtScaleDiv & | yScaleDiv |
| ) |  |  | `[virtual]`

Update the item to changes of the axes scale division.

In case of isScaleDivFromAxis(), the scale draw is synchronized to the correspond axis.

Parameters:

  | xScaleDiv | Scale division of the x-axis
  | yScaleDiv | Scale division of the y-axis

See also:
  QwtPlot::updateAxes()

Reimplemented from QwtPlotItem.

Definition at line 443 of file qwt_plot_scaleitem.cpp.

References QwtScaleDraw::orientation(), and QwtAbstractScaleDraw::setScaleDiv().

Referenced by setScaleDivFromAxis(), and setScaleDraw().